
_Evaluate_Hand:

;BlackJack.mbas,65 :: 		dim CurrentCard         as byte
;BlackJack.mbas,67 :: 		if Players[PlayerNumber].Outcome > TBD then                                   ' Outcome already determined
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__Evaluate_Hand2
;BlackJack.mbas,68 :: 		RESULT = Players[PlayerNumber].SumHand                                      ' set function to return existing sum
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       13
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Evaluate_Hand_local_result+0 
	GOTO        L__Evaluate_Hand3
;BlackJack.mbas,69 :: 		else
L__Evaluate_Hand2:
;BlackJack.mbas,70 :: 		ongoingsum = 0                                                              ' My Ongoing Sum
	CLRF        Evaluate_Hand_ongoingsum+0 
;BlackJack.mbas,71 :: 		aces = 0                                                                    ' Number of Aces
	CLRF        Evaluate_Hand_aces+0 
;BlackJack.mbas,72 :: 		for i = 1 to Players[PlayerNumber].Hand.Cards[CARD_COUNT]                   ' lets check each card in the hand
	MOVLW       1
	MOVWF       Evaluate_Hand_i+0 
L__Evaluate_Hand4:
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       FSR2L+0 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       FSR2L+1 
	MOVF        POSTINC2+0, 0 
	MOVWF       FLOC__Evaluate_Hand+0 
	MOVLW       128
	XORWF       FLOC__Evaluate_Hand+0, 0 
	MOVWF       R0 
	MOVLW       128
	XORWF       Evaluate_Hand_i+0, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Evaluate_Hand8
;BlackJack.mbas,73 :: 		CurrentCard = Retrieve_Card_Value(Players[PlayerNumber].Hand.Cards[i])    ' retrieve the card value
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVF        Evaluate_Hand_i+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	BTFSC       Evaluate_Hand_i+0, 7 
	MOVLW       255
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Retrieve_Card_Value_Card+0 
	CALL        _Retrieve_Card_Value+0, 0
	MOVF        R0, 0 
	MOVWF       Evaluate_Hand_CurrentCard+0 
;BlackJack.mbas,74 :: 		if CurrentCard > 10 then                                                  ' if it is J, Q, or K
	MOVF        R0, 0 
	SUBLW       10
	BTFSC       STATUS+0, 0 
	GOTO        L__Evaluate_Hand10
;BlackJack.mbas,75 :: 		ongoingsum = ongoingsum + 10                                            ' add 10 to the ongoingsum
	MOVLW       10
	ADDWF       Evaluate_Hand_ongoingsum+0, 1 
;BlackJack.mbas,76 :: 		continue                                                                ' check the next card
	GOTO        L__Evaluate_Hand6
L__Evaluate_Hand10:
;BlackJack.mbas,78 :: 		if CurrentCard > 1 then                                                   ' if it is 2-10
	MOVF        Evaluate_Hand_CurrentCard+0, 0 
	SUBLW       1
	BTFSC       STATUS+0, 0 
	GOTO        L__Evaluate_Hand13
;BlackJack.mbas,79 :: 		ongoingsum = ongoingsum + CurrentCard                                   ' add the card to the ongoing sum
	MOVF        Evaluate_Hand_CurrentCard+0, 0 
	ADDWF       Evaluate_Hand_ongoingsum+0, 1 
;BlackJack.mbas,80 :: 		continue                                                                ' check the next card
	GOTO        L__Evaluate_Hand6
L__Evaluate_Hand13:
;BlackJack.mbas,82 :: 		if CurrentCard = 1 then                                                   ' if it is 1, then we have an ace
	MOVF        Evaluate_Hand_CurrentCard+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Evaluate_Hand16
;BlackJack.mbas,83 :: 		aces = aces + 1                                                         ' increment our aces count
	INCF        Evaluate_Hand_aces+0, 1 
L__Evaluate_Hand16:
;BlackJack.mbas,85 :: 		next i
L__Evaluate_Hand6:
	MOVF        Evaluate_Hand_i+0, 0 
	XORWF       FLOC__Evaluate_Hand+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__Evaluate_Hand8
	INCF        Evaluate_Hand_i+0, 1 
	GOTO        L__Evaluate_Hand4
L__Evaluate_Hand8:
;BlackJack.mbas,87 :: 		if aces > 0 then                                                            ' if there is an ace or more in the hand
	MOVLW       128
	XORLW       0
	MOVWF       R0 
	MOVLW       128
	XORWF       Evaluate_Hand_aces+0, 0 
	SUBWF       R0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__Evaluate_Hand19
;BlackJack.mbas,88 :: 		if (ongoingsum + 11 + (aces - 1)) <= 21 then                              ' Check the sum using one of the aces as 11 (only 1 ace can be 11)
	MOVLW       11
	ADDWF       Evaluate_Hand_ongoingsum+0, 0 
	MOVWF       R1 
	DECF        Evaluate_Hand_aces+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	ADDWF       R1, 1 
	MOVLW       128
	XORLW       21
	MOVWF       R0 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Evaluate_Hand22
;BlackJack.mbas,89 :: 		ongoingsum = ongoingsum + 11 + (aces - 1)                               ' if that works, then that is our new total
	MOVLW       11
	ADDWF       Evaluate_Hand_ongoingsum+0, 1 
	DECF        Evaluate_Hand_aces+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	ADDWF       Evaluate_Hand_ongoingsum+0, 1 
	GOTO        L__Evaluate_Hand23
;BlackJack.mbas,90 :: 		else
L__Evaluate_Hand22:
;BlackJack.mbas,91 :: 		ongoingsum = ongoingsum + aces                                          ' if it doesn't work, add the aces as simply 1
	MOVF        Evaluate_Hand_aces+0, 0 
	ADDWF       Evaluate_Hand_ongoingsum+0, 1 
;BlackJack.mbas,92 :: 		end if
L__Evaluate_Hand23:
L__Evaluate_Hand19:
;BlackJack.mbas,95 :: 		Players[PlayerNumber].SumHand = ongoingsum                                  ' put the new sum in the player's hand
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       13
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        Evaluate_Hand_ongoingsum+0, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,96 :: 		RESULT = ongoingsum                                                         ' set the function to return that sum
	MOVF        Evaluate_Hand_ongoingsum+0, 0 
	MOVWF       Evaluate_Hand_local_result+0 
;BlackJack.mbas,99 :: 		if ((Players[PlayerNumber].SumHand = 21) and (Players[PlayerNumber].Move = 0)) then    ' if player has 21 and hasn't moved
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       13
	ADDWF       R2, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       21
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R2 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       21
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R2, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Evaluate_Hand25
;BlackJack.mbas,100 :: 		Players[PlayerNumber].Outcome = BLACKJACK                                            ' BLACKJACK
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       1
	MOVWF       POSTINC1+0 
L__Evaluate_Hand25:
;BlackJack.mbas,103 :: 		if ((Players[PlayerNumber].SumHand = 21) and (Players[PlayerNumber].Move > 0)) then    ' if player has 21 but has moved
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       13
	ADDWF       R2, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       21
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R2 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       21
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	SUBLW       0
	MOVLW       255
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R0 
	MOVF        R2, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Evaluate_Hand28
;BlackJack.mbas,104 :: 		Players[PlayerNumber].Outcome = TWENTYONE                                            ' still show them 21, cause can't take another card
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       7
	MOVWF       POSTINC1+0 
L__Evaluate_Hand28:
;BlackJack.mbas,107 :: 		if (Players[PlayerNumber].SumHand > 21) then                                           ' if player is over 21
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       13
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	SUBLW       21
	BTFSC       STATUS+0, 0 
	GOTO        L__Evaluate_Hand31
;BlackJack.mbas,108 :: 		Players[PlayerNumber].Outcome = BUST                                                 ' then player is bust
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        FARG_Evaluate_Hand_PlayerNumber+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       6
	MOVWF       POSTINC1+0 
L__Evaluate_Hand31:
;BlackJack.mbas,111 :: 		end if
L__Evaluate_Hand3:
;BlackJack.mbas,112 :: 		end sub
	MOVF        Evaluate_Hand_local_result+0, 0 
	MOVWF       R0 
L_end_Evaluate_Hand:
	RETURN      0
; end of _Evaluate_Hand

_update_scores:

;BlackJack.mbas,117 :: 		dim i as byte
;BlackJack.mbas,118 :: 		for i = 0 to NumberPlayers             ' For every player
	CLRF        update_scores_i+0 
L__update_scores34:
	MOVF        update_scores_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__update_scores38
;BlackJack.mbas,119 :: 		Evaluate_Hand(i)                     ' Evaluate their hand
	MOVF        update_scores_i+0, 0 
	MOVWF       FARG_Evaluate_Hand_PlayerNumber+0 
	CALL        _Evaluate_Hand+0, 0
;BlackJack.mbas,120 :: 		next i
	MOVF        update_scores_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__update_scores38
	INCF        update_scores_i+0, 1 
	GOTO        L__update_scores34
L__update_scores38:
;BlackJack.mbas,121 :: 		end sub
L_end_update_scores:
	RETURN      0
; end of _update_scores

_Print_And_Adjust_Totals:

;BlackJack.mbas,129 :: 		dim DealerBlackJack as boolean
;BlackJack.mbas,131 :: 		DealerBlackJack = false               ' Initialize the variable
	CLRF        Print_And_Adjust_Totals_DealerBlackJack+0 
;BlackJack.mbas,132 :: 		dealertotal = 0                       ' Used to see how much the dealer gains or loses
	CLRF        Print_And_Adjust_Totals_dealertotal+0 
	CLRF        Print_And_Adjust_Totals_dealertotal+1 
;BlackJack.mbas,133 :: 		if Players[DEALER].Outcome = BLACKJACK then   ' Let's set a boolean for whether dealer got a blackjack
	MOVF        _Players+20, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals41
;BlackJack.mbas,134 :: 		DealerBlackJack = true              ' This is for insurance purposes
	MOVLW       255
	MOVWF       Print_And_Adjust_Totals_DealerBlackJack+0 
L__Print_And_Adjust_Totals41:
;BlackJack.mbas,136 :: 		ClearGLCD()
	CALL        _ClearGLCD+0, 0
;BlackJack.mbas,137 :: 		For i = 1 to NumberPlayers            ' First display player ledgers
	MOVLW       1
	MOVWF       Print_And_Adjust_Totals_i+0 
L__Print_And_Adjust_Totals43:
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Print_And_Adjust_Totals47
;BlackJack.mbas,138 :: 		if (Players[i].Outcome = OUT) then  ' Skip those who did not play
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals49
;BlackJack.mbas,139 :: 		continue                          ' Next player...
	GOTO        L__Print_And_Adjust_Totals45
L__Print_And_Adjust_Totals49:
;BlackJack.mbas,141 :: 		playerstart     = Players[i].Bank       ' Set the player's starting balance
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       14
	ADDWF       R2, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Print_And_Adjust_Totals_playerstart+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Print_And_Adjust_Totals_playerstart+1 
;BlackJack.mbas,142 :: 		playerbet       = Players[i].Bet        ' Set the player's current bet
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       16
	ADDWF       R2, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Print_And_Adjust_Totals_playerbet+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Print_And_Adjust_Totals_playerbet+1 
;BlackJack.mbas,143 :: 		playerinsurance = Players[i].Insurance  ' Set the player's current insurance
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       18
	ADDWF       R2, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       Print_And_Adjust_Totals_playerinsurance+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       Print_And_Adjust_Totals_playerinsurance+1 
;BlackJack.mbas,145 :: 		if (Players[i].Outcome = BLACKJACK) then
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals52
;BlackJack.mbas,146 :: 		playerbet = (playerbet + (playerbet div 2))     ' Give winer 3:2
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	MOVWF       R0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	BTFSC       R1, 6 
	BSF         R1, 7 
	BTFSS       R1, 7 
	GOTO        L__Print_And_Adjust_Totals284
	BTFSS       STATUS+0, 0 
	GOTO        L__Print_And_Adjust_Totals284
	INFSNZ      R0, 1 
	INCF        R1, 1 
L__Print_And_Adjust_Totals284:
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	ADDWF       R0, 1 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       Print_And_Adjust_Totals_playerbet+0 
	MOVF        R1, 0 
	MOVWF       Print_And_Adjust_Totals_playerbet+1 
;BlackJack.mbas,147 :: 		dealertotal = dealertotal - playerbet           ' Give bet to the dealer
	MOVF        R0, 0 
	SUBWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        R1, 0 
	SUBWFB      Print_And_Adjust_Totals_dealertotal+1, 1 
;BlackJack.mbas,148 :: 		playertotal = playerstart + playerbet           ' Subtract get from the player
	MOVF        R0, 0 
	ADDWF       Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+0 
	MOVF        R1, 0 
	ADDWFC      Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+1 
;BlackJack.mbas,149 :: 		if playerinsurance > 0 then                     ' Was there an insurance bet?
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals285
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBLW       0
L__Print_And_Adjust_Totals285:
	BTFSC       STATUS+0, 0 
	GOTO        L__Print_And_Adjust_Totals55
;BlackJack.mbas,150 :: 		if DealerBlackJack then                       ' Did dealer get blackjack?
	MOVF        Print_And_Adjust_Totals_DealerBlackJack+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals58
;BlackJack.mbas,151 :: 		playerinsurance = playerinsurance * 2       ' If so, then insurance bet pays off 2x
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	MOVWF       R0 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	MOVWF       Print_And_Adjust_Totals_playerinsurance+0 
	MOVF        R1, 0 
	MOVWF       Print_And_Adjust_Totals_playerinsurance+1 
;BlackJack.mbas,152 :: 		playertotal = playertotal + playerinsurance ' Update the player total
	MOVF        R0, 0 
	ADDWF       Print_And_Adjust_Totals_playertotal+0, 1 
	MOVF        R1, 0 
	ADDWFC      Print_And_Adjust_Totals_playertotal+1, 1 
;BlackJack.mbas,153 :: 		dealertotal = dealertotal - playerinsurance ' Dealer loses that money
	MOVF        R0, 0 
	SUBWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        R1, 0 
	SUBWFB      Print_And_Adjust_Totals_dealertotal+1, 1 
	GOTO        L__Print_And_Adjust_Totals59
;BlackJack.mbas,154 :: 		else                                          ' If dealer did not get a blackjack
L__Print_And_Adjust_Totals58:
;BlackJack.mbas,155 :: 		playertotal = playertotal - playerinsurance ' Insurance did not pay off
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBWF       Print_And_Adjust_Totals_playertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWFB      Print_And_Adjust_Totals_playertotal+1, 1 
;BlackJack.mbas,156 :: 		dealertotal = dealertotal + playerinsurance ' Dealer keeps the insurance money
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	ADDWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	ADDWFC      Print_And_Adjust_Totals_dealertotal+1, 1 
;BlackJack.mbas,157 :: 		end if
L__Print_And_Adjust_Totals59:
L__Print_And_Adjust_Totals55:
;BlackJack.mbas,159 :: 		Players[i].Bank = playertotal                   ' Record the player's new total
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,160 :: 		DISPLAY_GLCD_LEDGER_ENTRY(i, BLACKJACK, playerstart, playerbet, playerinsurance, playertotal, DealerBlackJack) ' Print the result
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerId+0 
	MOVLW       1
	MOVWF       FARG_Display_GLCD_Ledger_Entry_OutCome+0 
	MOVF        Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+0 
	MOVF        Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+1 
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+0 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+1 
	MOVF        Print_And_Adjust_Totals_DealerBlackJack+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_DealerBlackJack+0 
	CALL        _Display_GLCD_Ledger_Entry+0, 0
L__Print_And_Adjust_Totals52:
;BlackJack.mbas,163 :: 		if (Players[i].Outcome = WIN) then
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals61
;BlackJack.mbas,164 :: 		dealertotal = dealertotal - playerbet           ' Give bet to the dealer
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	SUBWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	SUBWFB      Print_And_Adjust_Totals_dealertotal+1, 1 
;BlackJack.mbas,165 :: 		playertotal = playerstart + playerbet           ' Subtract get from the player
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	ADDWF       Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	ADDWFC      Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+1 
;BlackJack.mbas,166 :: 		if playerinsurance > 0 then                     ' Was there an insurance bet?
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals286
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBLW       0
L__Print_And_Adjust_Totals286:
	BTFSC       STATUS+0, 0 
	GOTO        L__Print_And_Adjust_Totals64
;BlackJack.mbas,167 :: 		playertotal = playertotal - playerinsurance   ' Insurance did not pay off
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBWF       Print_And_Adjust_Totals_playertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWFB      Print_And_Adjust_Totals_playertotal+1, 1 
;BlackJack.mbas,168 :: 		dealertotal = dealertotal + playerinsurance   ' Dealer keeps the insurance money
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	ADDWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	ADDWFC      Print_And_Adjust_Totals_dealertotal+1, 1 
L__Print_And_Adjust_Totals64:
;BlackJack.mbas,170 :: 		Players[i].Bank = playertotal                   ' Record the player's new total
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,171 :: 		DISPLAY_GLCD_LEDGER_ENTRY(i, WIN, playerstart, playerbet, playerinsurance, playertotal, DealerBlackJack) ' Print the result
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerId+0 
	MOVLW       3
	MOVWF       FARG_Display_GLCD_Ledger_Entry_OutCome+0 
	MOVF        Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+0 
	MOVF        Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+1 
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+0 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+1 
	MOVF        Print_And_Adjust_Totals_DealerBlackJack+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_DealerBlackJack+0 
	CALL        _Display_GLCD_Ledger_Entry+0, 0
L__Print_And_Adjust_Totals61:
;BlackJack.mbas,174 :: 		if (Players[i].Outcome = DRAW) then
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals67
;BlackJack.mbas,175 :: 		playerbet = 0                                   ' No money changes hands
	CLRF        Print_And_Adjust_Totals_playerbet+0 
	CLRF        Print_And_Adjust_Totals_playerbet+1 
;BlackJack.mbas,176 :: 		playertotal = playerstart                       ' Copy starting amount
	MOVF        Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+0 
	MOVF        Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+1 
;BlackJack.mbas,177 :: 		if playerinsurance > 0 then                     ' Was there an insurance bet?
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals287
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBLW       0
L__Print_And_Adjust_Totals287:
	BTFSC       STATUS+0, 0 
	GOTO        L__Print_And_Adjust_Totals70
;BlackJack.mbas,178 :: 		playertotal = playertotal - playerinsurance   ' Insurance did not pay off
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBWF       Print_And_Adjust_Totals_playertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWFB      Print_And_Adjust_Totals_playertotal+1, 1 
;BlackJack.mbas,179 :: 		dealertotal = dealertotal + playerinsurance   ' Dealer keeps the insurance money
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	ADDWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	ADDWFC      Print_And_Adjust_Totals_dealertotal+1, 1 
L__Print_And_Adjust_Totals70:
;BlackJack.mbas,181 :: 		DISPLAY_GLCD_LEDGER_ENTRY(i, DRAW, playerstart, playerbet, playerinsurance, playertotal, DealerBlackJack) ' Print the result
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerId+0 
	MOVLW       4
	MOVWF       FARG_Display_GLCD_Ledger_Entry_OutCome+0 
	MOVF        Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+0 
	MOVF        Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+1 
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+0 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+1 
	MOVF        Print_And_Adjust_Totals_DealerBlackJack+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_DealerBlackJack+0 
	CALL        _Display_GLCD_Ledger_Entry+0, 0
L__Print_And_Adjust_Totals67:
;BlackJack.mbas,184 :: 		if (Players[i].Outcome = SURRENDER) then
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals73
;BlackJack.mbas,185 :: 		dealertotal = dealertotal + playerbet           ' Give bet to the dealer
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	ADDWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	ADDWFC      Print_And_Adjust_Totals_dealertotal+1, 1 
;BlackJack.mbas,186 :: 		playertotal = playerstart - playerbet           ' Subtract bet from the player
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	SUBWF       Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	SUBWFB      Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+1 
;BlackJack.mbas,187 :: 		if playerinsurance > 0 then                     ' Was there an insurance bet?
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals288
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBLW       0
L__Print_And_Adjust_Totals288:
	BTFSC       STATUS+0, 0 
	GOTO        L__Print_And_Adjust_Totals76
;BlackJack.mbas,188 :: 		playertotal = playertotal - playerinsurance   ' Insurance did not pay off
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBWF       Print_And_Adjust_Totals_playertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWFB      Print_And_Adjust_Totals_playertotal+1, 1 
;BlackJack.mbas,189 :: 		dealertotal = dealertotal + playerinsurance   ' Dealer keeps the insurance money
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	ADDWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	ADDWFC      Print_And_Adjust_Totals_dealertotal+1, 1 
L__Print_And_Adjust_Totals76:
;BlackJack.mbas,191 :: 		Players[i].Bank = playertotal                   ' Record the player's new total
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,192 :: 		DISPLAY_GLCD_LEDGER_ENTRY(i, SURRENDER, playerstart, playerbet, playerinsurance, playertotal, DealerBlackJack) ' Print the result
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerId+0 
	MOVLW       2
	MOVWF       FARG_Display_GLCD_Ledger_Entry_OutCome+0 
	MOVF        Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+0 
	MOVF        Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+1 
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+0 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+1 
	MOVF        Print_And_Adjust_Totals_DealerBlackJack+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_DealerBlackJack+0 
	CALL        _Display_GLCD_Ledger_Entry+0, 0
L__Print_And_Adjust_Totals73:
;BlackJack.mbas,195 :: 		if (Players[i].Outcome = LOSE) then
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals79
;BlackJack.mbas,196 :: 		dealertotal = dealertotal + playerbet           ' Give bet to the dealer
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	ADDWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	ADDWFC      Print_And_Adjust_Totals_dealertotal+1, 1 
;BlackJack.mbas,197 :: 		playertotal = playerstart - playerbet           ' Subtract bet from the player
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	SUBWF       Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	SUBWFB      Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+1 
;BlackJack.mbas,198 :: 		if playerinsurance > 0 then                     ' Was there an insurance bet?
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals289
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBLW       0
L__Print_And_Adjust_Totals289:
	BTFSC       STATUS+0, 0 
	GOTO        L__Print_And_Adjust_Totals82
;BlackJack.mbas,199 :: 		playertotal = playertotal - playerinsurance   ' Insurance did not pay off
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBWF       Print_And_Adjust_Totals_playertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWFB      Print_And_Adjust_Totals_playertotal+1, 1 
;BlackJack.mbas,200 :: 		dealertotal = dealertotal + playerinsurance   ' Dealer keeps the insurance money
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	ADDWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	ADDWFC      Print_And_Adjust_Totals_dealertotal+1, 1 
L__Print_And_Adjust_Totals82:
;BlackJack.mbas,202 :: 		Players[i].Bank = playertotal                   ' Record the player's new total
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,203 :: 		DISPLAY_GLCD_LEDGER_ENTRY(i, LOSE, playerstart, playerbet, playerinsurance, playertotal, DealerBlackJack) ' Print the result
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerId+0 
	MOVLW       5
	MOVWF       FARG_Display_GLCD_Ledger_Entry_OutCome+0 
	MOVF        Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+0 
	MOVF        Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+1 
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+0 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+1 
	MOVF        Print_And_Adjust_Totals_DealerBlackJack+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_DealerBlackJack+0 
	CALL        _Display_GLCD_Ledger_Entry+0, 0
L__Print_And_Adjust_Totals79:
;BlackJack.mbas,206 :: 		if (Players[i].Outcome = BUST) then
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals85
;BlackJack.mbas,207 :: 		dealertotal = dealertotal + playerbet           ' Give bet to the dealer
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	ADDWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	ADDWFC      Print_And_Adjust_Totals_dealertotal+1, 1 
;BlackJack.mbas,208 :: 		playertotal = playerstart - playerbet           ' Subtract bet from the player
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	SUBWF       Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	SUBWFB      Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+1 
;BlackJack.mbas,209 :: 		if playerinsurance > 0 then                     ' Was there an insurance bet?
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals290
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBLW       0
L__Print_And_Adjust_Totals290:
	BTFSC       STATUS+0, 0 
	GOTO        L__Print_And_Adjust_Totals88
;BlackJack.mbas,210 :: 		playertotal = playertotal - playerinsurance   ' Insurance did not pay off
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	SUBWF       Print_And_Adjust_Totals_playertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	SUBWFB      Print_And_Adjust_Totals_playertotal+1, 1 
;BlackJack.mbas,211 :: 		dealertotal = dealertotal + playerinsurance   ' Dealer keeps the insurance money
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	ADDWF       Print_And_Adjust_Totals_dealertotal+0, 1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	ADDWFC      Print_And_Adjust_Totals_dealertotal+1, 1 
L__Print_And_Adjust_Totals88:
;BlackJack.mbas,213 :: 		Players[i].Bank = playertotal                   ' Record the player's new total
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,214 :: 		DISPLAY_GLCD_LEDGER_ENTRY(i, BUST, playerstart, playerbet, playerinsurance, playertotal, DealerBlackJack) ' Print the result
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerId+0 
	MOVLW       6
	MOVWF       FARG_Display_GLCD_Ledger_Entry_OutCome+0 
	MOVF        Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+0 
	MOVF        Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+1 
	MOVF        Print_And_Adjust_Totals_playerbet+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+0 
	MOVF        Print_And_Adjust_Totals_playerbet+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+1 
	MOVF        Print_And_Adjust_Totals_playerinsurance+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+0 
	MOVF        Print_And_Adjust_Totals_playerinsurance+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_Insurance+1 
	MOVF        Print_And_Adjust_Totals_playertotal+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+0 
	MOVF        Print_And_Adjust_Totals_playertotal+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+1 
	MOVF        Print_And_Adjust_Totals_DealerBlackJack+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_DealerBlackJack+0 
	CALL        _Display_GLCD_Ledger_Entry+0, 0
L__Print_And_Adjust_Totals85:
;BlackJack.mbas,217 :: 		next i
L__Print_And_Adjust_Totals45:
	MOVF        Print_And_Adjust_Totals_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__Print_And_Adjust_Totals47
	INCF        Print_And_Adjust_Totals_i+0, 1 
	GOTO        L__Print_And_Adjust_Totals43
L__Print_And_Adjust_Totals47:
;BlackJack.mbas,220 :: 		playerstart = Players[DEALER].Bank                  ' Set the starting bank for the dealer for display
	MOVF        _Players+14, 0 
	MOVWF       Print_And_Adjust_Totals_playerstart+0 
	MOVF        _Players+15, 0 
	MOVWF       Print_And_Adjust_Totals_playerstart+1 
;BlackJack.mbas,221 :: 		playerbet = dealertotal                             ' Set how much the dealer won or lost
	MOVF        Print_And_Adjust_Totals_dealertotal+0, 0 
	MOVWF       Print_And_Adjust_Totals_playerbet+0 
	MOVF        Print_And_Adjust_Totals_dealertotal+1, 0 
	MOVWF       Print_And_Adjust_Totals_playerbet+1 
;BlackJack.mbas,222 :: 		playertotal = playerstart + playerbet               ' Set the outcome on the dealer's bank
	MOVF        Print_And_Adjust_Totals_dealertotal+0, 0 
	ADDWF       _Players+14, 0 
	MOVWF       R0 
	MOVF        Print_And_Adjust_Totals_dealertotal+1, 0 
	ADDWFC      _Players+15, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+0 
	MOVF        R1, 0 
	MOVWF       Print_And_Adjust_Totals_playertotal+1 
;BlackJack.mbas,223 :: 		Players[DEALER].Bank=playertotal                    ' Record the outcome in the dealer's bank
	MOVF        R0, 0 
	MOVWF       _Players+14 
	MOVF        R1, 0 
	MOVWF       _Players+15 
;BlackJack.mbas,224 :: 		DISPLAY_GLCD_LEDGER_ENTRY(DEALER, TBD, playerstart, playerbet, 0, playertotal, false) ' Print the result
	CLRF        FARG_Display_GLCD_Ledger_Entry_PlayerId+0 
	CLRF        FARG_Display_GLCD_Ledger_Entry_OutCome+0 
	MOVF        Print_And_Adjust_Totals_playerstart+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+0 
	MOVF        Print_And_Adjust_Totals_playerstart+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerStart+1 
	MOVF        Print_And_Adjust_Totals_dealertotal+0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+0 
	MOVF        Print_And_Adjust_Totals_dealertotal+1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerBet+1 
	CLRF        FARG_Display_GLCD_Ledger_Entry_Insurance+0 
	CLRF        FARG_Display_GLCD_Ledger_Entry_Insurance+1 
	MOVF        R0, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+0 
	MOVF        R1, 0 
	MOVWF       FARG_Display_GLCD_Ledger_Entry_PlayerTotal+1 
	CLRF        FARG_Display_GLCD_Ledger_Entry_DealerBlackJack+0 
	CALL        _Display_GLCD_Ledger_Entry+0, 0
;BlackJack.mbas,226 :: 		end sub
L_end_Print_And_Adjust_Totals:
	RETURN      0
; end of _Print_And_Adjust_Totals

_init_rand:

;BlackJack.mbas,232 :: 		dim seed               as word
;BlackJack.mbas,233 :: 		seed = 1                                            ' Initialize the seed, although not really necessary but habbit
	MOVLW       1
	MOVWF       init_rand_seed+0 
	MOVLW       0
	MOVWF       init_rand_seed+1 
;BlackJack.mbas,234 :: 		while true
L__init_rand92:
;BlackJack.mbas,235 :: 		if Button(PORTC, 0, 100, 1) then                  ' Wait for a press on C0
	MOVLW       PORTC+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTC+0)
	MOVWF       FARG_Button_port+1 
	CLRF        FARG_Button_pin+0 
	MOVLW       100
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__init_rand97
;BlackJack.mbas,236 :: 		break                                           ' Break out of while loop on press
	GOTO        L__init_rand93
L__init_rand97:
;BlackJack.mbas,238 :: 		inc(seed)                                         ' While waiting, quickly keep incrementing the seed
	INFSNZ      init_rand_seed+0, 1 
	INCF        init_rand_seed+1, 1 
;BlackJack.mbas,239 :: 		wend
	GOTO        L__init_rand92
L__init_rand93:
;BlackJack.mbas,240 :: 		srand(seed)                                         ' Initialize the random number generator with the seed
	MOVF        init_rand_seed+0, 0 
	MOVWF       FARG_srand_x+0 
	MOVF        init_rand_seed+1, 0 
	MOVWF       FARG_srand_x+1 
	CALL        _srand+0, 0
;BlackJack.mbas,241 :: 		end sub
L_end_init_rand:
	RETURN      0
; end of _init_rand

_Discard_Players_Cards:

;BlackJack.mbas,245 :: 		dim i, j as byte
;BlackJack.mbas,247 :: 		DISPLAY_LCD_DISCARDING_HANDS_MSG()                  ' Always notify user of actions, such as putting hands in discard pile
	CALL        _Display_LCD_Discarding_Hands_Msg+0, 0
;BlackJack.mbas,249 :: 		for i = 0 to NumberPlayers                          ' For each player
	CLRF        Discard_Players_Cards_i+0 
L__Discard_Players_Cards100:
	MOVF        Discard_Players_Cards_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Discard_Players_Cards104
;BlackJack.mbas,250 :: 		Transfer_Hand_To_Deck(@Players[i].Hand,@DiscardPile)  ' Transfer the player's hand to discard pile
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Discard_Players_Cards_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       FARG_Transfer_Hand_To_Deck_PtrSource+0 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_Transfer_Hand_To_Deck_PtrSource+1 
	MOVLW       _DiscardPile+0
	MOVWF       FARG_Transfer_Hand_To_Deck_PtrTarget+0 
	MOVLW       hi_addr(_DiscardPile+0)
	MOVWF       FARG_Transfer_Hand_To_Deck_PtrTarget+1 
	CALL        _Transfer_Hand_To_Deck+0, 0
;BlackJack.mbas,251 :: 		next i
	MOVF        Discard_Players_Cards_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__Discard_Players_Cards104
	INCF        Discard_Players_Cards_i+0, 1 
	GOTO        L__Discard_Players_Cards100
L__Discard_Players_Cards104:
;BlackJack.mbas,252 :: 		end sub
L_end_Discard_Players_Cards:
	RETURN      0
; end of _Discard_Players_Cards

_Final_Outcomes:

;BlackJack.mbas,257 :: 		dim i, PlayerScore, DealerScore as byte
;BlackJack.mbas,259 :: 		Update_Scores()                                ' Make sure we are working with the latest known outcomes.
	CALL        _update_scores+0, 0
;BlackJack.mbas,260 :: 		DealerScore = Players[DEALER].SumHand          ' We need the dealer's score to compare with players scores
	MOVF        _Players+13, 0 
	MOVWF       Final_Outcomes_DealerScore+0 
;BlackJack.mbas,262 :: 		for i = 1 to NumberPlayers                     ' Let's go through the players
	MOVLW       1
	MOVWF       Final_Outcomes_i+0 
L__Final_Outcomes106:
	MOVF        Final_Outcomes_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Final_Outcomes110
;BlackJack.mbas,263 :: 		if ((Players[DEALER].Outcome = BLACKJACK) AND (Players[i].Outcome = BLACKJACK)) then ' First we need to handle the special case where player and dealer got blackjack
	MOVF        _Players+20, 0 
	XORLW       1
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       FLOC__Final_Outcomes+0 
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Final_Outcomes_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       1
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        FLOC__Final_Outcomes+0, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Final_Outcomes112
;BlackJack.mbas,264 :: 		Players[i].Outcome = DRAW                ' Give the player a draw
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Final_Outcomes_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       4
	MOVWF       POSTINC1+0 
;BlackJack.mbas,265 :: 		continue                                 ' Next player
	GOTO        L__Final_Outcomes108
L__Final_Outcomes112:
;BlackJack.mbas,267 :: 		if ((Players[i].Outcome = TBD) or (Players[i].Outcome = TWENTYONE)) then   ' If the player is still TBD or has 21 (not BLACKJACK)
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Final_Outcomes_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       20
	ADDWF       R2, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R2 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       7
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R2, 0 
	IORWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Final_Outcomes115
;BlackJack.mbas,268 :: 		if Players[DEALER].Outcome = BUST then     ' If the dealer is BUST, then all remaining players WIN
	MOVF        _Players+20, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L__Final_Outcomes118
;BlackJack.mbas,269 :: 		Players[i].Outcome = WIN                 ' Set the player outcome to win
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Final_Outcomes_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       3
	MOVWF       POSTINC1+0 
;BlackJack.mbas,270 :: 		continue                                 ' Next player
	GOTO        L__Final_Outcomes108
L__Final_Outcomes118:
;BlackJack.mbas,272 :: 		PlayerScore = Players[i].SumHand           ' Dealer is not bust, so get the player's score
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Final_Outcomes_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       13
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       Final_Outcomes_PlayerScore+0 
;BlackJack.mbas,273 :: 		if PlayerScore < DealerScore then          ' If player has a lower score than dealer
	MOVF        Final_Outcomes_DealerScore+0, 0 
	SUBWF       R1, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__Final_Outcomes121
;BlackJack.mbas,274 :: 		Players[i].Outcome = LOSE                ' Player loses
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Final_Outcomes_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       5
	MOVWF       POSTINC1+0 
;BlackJack.mbas,275 :: 		continue                                 ' Next player
	GOTO        L__Final_Outcomes108
L__Final_Outcomes121:
;BlackJack.mbas,277 :: 		if PlayerScore = DealerScore then          ' If player matches dealer score, then it is a draw
	MOVF        Final_Outcomes_PlayerScore+0, 0 
	XORWF       Final_Outcomes_DealerScore+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Final_Outcomes124
;BlackJack.mbas,278 :: 		Players[i].Outcome = DRAW                ' Give the player a draw
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Final_Outcomes_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       4
	MOVWF       POSTINC1+0 
;BlackJack.mbas,279 :: 		continue                                 ' Next player
	GOTO        L__Final_Outcomes108
L__Final_Outcomes124:
;BlackJack.mbas,281 :: 		if PlayerScore > DealerScore then          ' If the player has a higher score than the dealer
	MOVF        Final_Outcomes_PlayerScore+0, 0 
	SUBWF       Final_Outcomes_DealerScore+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__Final_Outcomes127
;BlackJack.mbas,282 :: 		Players[i].Outcome = WIN                 ' Player wins, give the player a win
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        Final_Outcomes_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       3
	MOVWF       POSTINC1+0 
;BlackJack.mbas,283 :: 		continue                                 ' Next player, although technically this would happen anyway
	GOTO        L__Final_Outcomes108
L__Final_Outcomes127:
;BlackJack.mbas,284 :: 		end if
L__Final_Outcomes115:
;BlackJack.mbas,286 :: 		next i
L__Final_Outcomes108:
	MOVF        Final_Outcomes_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__Final_Outcomes110
	INCF        Final_Outcomes_i+0, 1 
	GOTO        L__Final_Outcomes106
L__Final_Outcomes110:
;BlackJack.mbas,287 :: 		end sub
L_end_Final_Outcomes:
	RETURN      0
; end of _Final_Outcomes

_Get_CardDeck_Card:

;BlackJack.mbas,289 :: 		sub function Get_CardDeck_Card() as byte
;BlackJack.mbas,293 :: 		if CardDeck.Cards[CARD_COUNT] = 0 then        ' We are out of cards, need to refill
	MOVF        _CardDeck+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__Get_CardDeck_Card131
;BlackJack.mbas,294 :: 		DISPLAY_LCD_REFILL_MSG()                    ' Notify players discards being added
	CALL        _Display_LCD_Refill_Msg+0, 0
;BlackJack.mbas,295 :: 		Transfer_Deck_To_Deck(@DiscardPile, @CardDeck) ' Move Discard Pile to Card Deck
	MOVLW       _DiscardPile+0
	MOVWF       FARG_Transfer_Deck_To_Deck_PtrSource+0 
	MOVLW       hi_addr(_DiscardPile+0)
	MOVWF       FARG_Transfer_Deck_To_Deck_PtrSource+1 
	MOVLW       _CardDeck+0
	MOVWF       FARG_Transfer_Deck_To_Deck_PtrTarget+0 
	MOVLW       hi_addr(_CardDeck+0)
	MOVWF       FARG_Transfer_Deck_To_Deck_PtrTarget+1 
	CALL        _Transfer_Deck_To_Deck+0, 0
;BlackJack.mbas,296 :: 		DISPLAY_LCD_SHUFFLING_MSG()                 ' Let players know we are suffling
	CALL        _Display_LCD_Shuffling_Msg+0, 0
;BlackJack.mbas,297 :: 		Shuffle_Deck(@CardDeck)                     ' Shuffle the deck
	MOVLW       _CardDeck+0
	MOVWF       FARG_Shuffle_Deck_PtrDeck+0 
	MOVLW       hi_addr(_CardDeck+0)
	MOVWF       FARG_Shuffle_Deck_PtrDeck+1 
	CALL        _Shuffle_Deck+0, 0
L__Get_CardDeck_Card131:
;BlackJack.mbas,299 :: 		result = Get_Top_Card_From_Deck(@CardDeck)    ' Return the top card from the new deck
	MOVLW       _CardDeck+0
	MOVWF       FARG_Get_Top_Card_From_Deck_PtrDeck+0 
	MOVLW       hi_addr(_CardDeck+0)
	MOVWF       FARG_Get_Top_Card_From_Deck_PtrDeck+1 
	CALL        _Get_Top_Card_From_Deck+0, 0
	MOVF        R0, 0 
	MOVWF       Get_CardDeck_Card_local_result+0 
;BlackJack.mbas,300 :: 		end sub
	MOVF        Get_CardDeck_Card_local_result+0, 0 
	MOVWF       R0 
L_end_Get_CardDeck_Card:
	RETURN      0
; end of _Get_CardDeck_Card

_main:

;BlackJack.mbas,313 :: 		dim PlayerAvailableBalance as integer         ' This is used for insurance purposes
;BlackJack.mbas,315 :: 		Init_Inputs()                                 ' Set the PORTC stuff to input
	CALL        _Init_Inputs+0, 0
;BlackJack.mbas,316 :: 		DISPLAY_LCD_Start_Msg()                       ' Print a cute start message
	CALL        _Display_LCD_Start_Msg+0, 0
;BlackJack.mbas,317 :: 		Init_Rand()                                   ' Use delay in pressing C0 to initialize random numbers
	CALL        _init_rand+0, 0
;BlackJack.mbas,318 :: 		Init_Empty_Deck(@DiscardPile)                 ' Discard Pile starts as empty or 0 cards
	MOVLW       _DiscardPile+0
	MOVWF       FARG_Init_Empty_Deck_PtrDeck+0 
	MOVLW       hi_addr(_DiscardPile+0)
	MOVWF       FARG_Init_Empty_Deck_PtrDeck+1 
	CALL        _Init_Empty_Deck+0, 0
;BlackJack.mbas,319 :: 		Init_Full_Deck(@CardDeck)                     ' Card Deck that we draw from is a fresh 52 cards
	MOVLW       _CardDeck+0
	MOVWF       FARG_Init_Full_Deck_PtrDeck+0 
	MOVLW       hi_addr(_CardDeck+0)
	MOVWF       FARG_Init_Full_Deck_PtrDeck+1 
	CALL        _Init_Full_Deck+0, 0
;BlackJack.mbas,320 :: 		PlayerStartingBalance = 500                   ' 500 allows a lot of room
	MOVLW       244
	MOVWF       main_PlayerStartingBalance+0 
	MOVLW       1
	MOVWF       main_PlayerStartingBalance+1 
;BlackJack.mbas,321 :: 		DealerStartingBalance = 20000                 ' 20000 is hard to beat
	MOVLW       32
	MOVWF       main_DealerStartingBalance+0 
	MOVLW       78
	MOVWF       main_DealerStartingBalance+1 
;BlackJack.mbas,325 :: 		if not INQUIRE_INSTRUCTIONS_LCD_BOOL() then   ' If the players do not want instructions
	CALL        _Inquire_Instructions_LCD_Bool+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main136
;BlackJack.mbas,326 :: 		goto DISPLAY_WINS                           ' Skip the instructions
	GOTO        L__main_display_wins
L__main136:
;BlackJack.mbas,329 :: 		PRINT_INSTRUCTIONS:
L__main_print_instructions:
;BlackJack.mbas,330 :: 		DISPLAY_GLCD_START_MSG()                      ' Print the instructions to the GLCD
	CALL        _Display_GLCD_Start_Msg+0, 0
;BlackJack.mbas,331 :: 		if INQUIRE_AGAIN_LCD_BOOL() then              ' Ask if the players want instructions again
	CALL        _Inquire_Again_LCD_Bool+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main141
;BlackJack.mbas,332 :: 		goto PRINT_INSTRUCTIONS                     ' If so, print the instructions again
	GOTO        L__main_print_instructions
L__main141:
;BlackJack.mbas,335 :: 		DISPLAY_WINS:
L__main_display_wins:
;BlackJack.mbas,336 :: 		NumberWins = Display_LCD_Number_Wins_Msg()    ' Display how many times the game has been won in the past from EEPROM
	CALL        _Display_LCD_Number_Wins_Msg+0, 0
	MOVF        R0, 0 
	MOVWF       main_NumberWins+0 
;BlackJack.mbas,339 :: 		NumberPlayers = INQUIRE_NUMBER_OF_PLAYERS()   ' Call input routine to get number of players
	CALL        _Inquire_Number_of_Players+0, 0
	MOVF        R0, 0 
	MOVWF       _NumberPlayers+0 
;BlackJack.mbas,342 :: 		for i = 1 to NumberPlayers                    ' Initialize all players position and money
	MOVLW       1
	MOVWF       main_i+0 
L__main145:
	MOVF        main_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__main149
;BlackJack.mbas,343 :: 		Players[i].Bank = PlayerStartingBalance     ' Players start with $500
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        main_PlayerStartingBalance+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        main_PlayerStartingBalance+1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,344 :: 		next i
	MOVF        main_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main149
	INCF        main_i+0, 1 
	GOTO        L__main145
L__main149:
;BlackJack.mbas,345 :: 		Players[DEALER].Bank = DealerStartingBalance  ' Give the Dealer $20000
	MOVF        main_DealerStartingBalance+0, 0 
	MOVWF       _Players+14 
	MOVF        main_DealerStartingBalance+1, 0 
	MOVWF       _Players+15 
;BlackJack.mbas,347 :: 		SHUFFLE:
L__main_shuffle:
;BlackJack.mbas,348 :: 		DISPLAY_LCD_SHUFFLING_MSG()                   ' Tell user we are shuffling
	CALL        _Display_LCD_Shuffling_Msg+0, 0
;BlackJack.mbas,349 :: 		Shuffle_Deck(@CardDeck)                       ' Shuffle the card deck
	MOVLW       _CardDeck+0
	MOVWF       FARG_Shuffle_Deck_PtrDeck+0 
	MOVLW       hi_addr(_CardDeck+0)
	MOVWF       FARG_Shuffle_Deck_PtrDeck+1 
	CALL        _Shuffle_Deck+0, 0
;BlackJack.mbas,352 :: 		for i = 0 to NumberPlayers                    ' For everyone, including the dealer
	CLRF        main_i+0 
L__main152:
	MOVF        main_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__main156
;BlackJack.mbas,353 :: 		Players[i].Bet              = 0             ' Nobody has bet
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       16
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;BlackJack.mbas,354 :: 		Players[i].SumHand          = 0             ' No cards, so no score
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       13
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
;BlackJack.mbas,355 :: 		Players[i].Move             = 0             ' No move has been made
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       21
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
;BlackJack.mbas,356 :: 		Players[i].Insurance        = 0             ' No insurance
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       18
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;BlackJack.mbas,357 :: 		Players[i].Outcome          = TBD           ' Outcomes are undetermined
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
;BlackJack.mbas,358 :: 		Init_Empty_Hand(@Players[i].Hand)           ' Players start without cards
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       FARG_Init_Empty_Hand_PtrHand+0 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_Init_Empty_Hand_PtrHand+1 
	CALL        _Init_Empty_Hand+0, 0
;BlackJack.mbas,359 :: 		next i
	MOVF        main_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main156
	INCF        main_i+0, 1 
	GOTO        L__main152
L__main156:
;BlackJack.mbas,362 :: 		FastHalf = false                              ' Start by assuming we will not quick bet
	CLRF        main_FastHalf+0 
;BlackJack.mbas,363 :: 		FastFull = false                              ' Start by assuming we will not quick bet
	CLRF        main_FastFull+0 
;BlackJack.mbas,364 :: 		for i = 1 to NumberPlayers                    ' For all players (not DEALER at 0)
	MOVLW       1
	MOVWF       main_i+0 
L__main158:
	MOVF        main_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__main162
;BlackJack.mbas,365 :: 		if Players[i].Bank > 0 then                 ' If they have money
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       R2, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main296
	MOVF        R1, 0 
	SUBLW       0
L__main296:
	BTFSC       STATUS+0, 0 
	GOTO        L__main164
;BlackJack.mbas,366 :: 		if FastFull then                          ' Bet All
	MOVF        main_FastFull+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main167
;BlackJack.mbas,367 :: 		Players[i].Bet = Players[i].Bank        ' Bet All
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       16
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,368 :: 		continue                                ' Next player
	GOTO        L__main160
L__main167:
;BlackJack.mbas,370 :: 		if FastHalf then                          ' If everyone is supposed to bet 1/2
	MOVF        main_FastHalf+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main170
;BlackJack.mbas,371 :: 		Players[i].Bet = Players[i].Bank div 2  ' Bet 1/2
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       16
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	BTFSC       R1, 6 
	BSF         R1, 7 
	BTFSS       R1, 7 
	GOTO        L__main297
	BTFSS       STATUS+0, 0 
	GOTO        L__main297
	INFSNZ      R0, 1 
	INCF        R1, 1 
L__main297:
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,372 :: 		continue                                ' Next Player
	GOTO        L__main160
L__main170:
;BlackJack.mbas,374 :: 		TempBet = INQUIRE_BET(Players[i].Bank, i, false) ' Get their bet
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Inquire_Bet_Limit+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Inquire_Bet_Limit+1 
	MOVF        main_i+0, 0 
	MOVWF       FARG_Inquire_Bet_PlayerNum+0 
	CLRF        FARG_Inquire_Bet_Insurance+0 
	CALL        _Inquire_Bet+0, 0
	MOVF        R0, 0 
	MOVWF       main_TempBet+0 
	MOVF        R1, 0 
	MOVWF       main_TempBet+1 
;BlackJack.mbas,375 :: 		if TempBet < 0 then                       ' If the bet is less than 0
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main298
	MOVLW       0
	SUBWF       R0, 0 
L__main298:
	BTFSC       STATUS+0, 0 
	GOTO        L__main173
;BlackJack.mbas,376 :: 		if TempBet = -1 then                    ' if the bet is -1 then
	MOVLW       255
	XORWF       main_TempBet+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main299
	MOVLW       255
	XORWF       main_TempBet+0, 0 
L__main299:
	BTFSS       STATUS+0, 2 
	GOTO        L__main176
;BlackJack.mbas,377 :: 		FastFull = true                       ' Go Fast with Full Bets
	MOVLW       255
	MOVWF       main_FastFull+0 
;BlackJack.mbas,378 :: 		Players[i].Bet = Players[i].Bank      ' Make sure this player has a bet
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       16
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	GOTO        L__main177
;BlackJack.mbas,379 :: 		else                                    ' Else
L__main176:
;BlackJack.mbas,380 :: 		FastHalf = true                       ' Go Fast with Half Bets
	MOVLW       255
	MOVWF       main_FastHalf+0 
;BlackJack.mbas,381 :: 		Players[i].Bet = Players[i].Bank div 2  ' Make sure this player has a bet
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       16
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	BTFSC       R1, 6 
	BSF         R1, 7 
	BTFSS       R1, 7 
	GOTO        L__main300
	BTFSS       STATUS+0, 0 
	GOTO        L__main300
	INFSNZ      R0, 1 
	INCF        R1, 1 
L__main300:
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,382 :: 		end if
L__main177:
;BlackJack.mbas,383 :: 		continue                                ' Next Player
	GOTO        L__main160
L__main173:
;BlackJack.mbas,385 :: 		Players[i].Bet = TempBet                  ' Otherwise just record the bet
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       16
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        main_TempBet+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        main_TempBet+1, 0 
	MOVWF       POSTINC1+0 
	GOTO        L__main165
;BlackJack.mbas,386 :: 		ELSE                                        ' If they have no money
L__main164:
;BlackJack.mbas,387 :: 		Players[i].Bet = 0                        ' They have a 0 bet
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       16
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;BlackJack.mbas,388 :: 		Players[i].Outcome = OUT                  ' They are out this hand
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       8
	MOVWF       POSTINC1+0 
;BlackJack.mbas,389 :: 		end if
L__main165:
;BlackJack.mbas,390 :: 		next i
L__main160:
	MOVF        main_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main162
	INCF        main_i+0, 1 
	GOTO        L__main158
L__main162:
;BlackJack.mbas,393 :: 		for j = 0 TO 1                                ' Deal 2 cards
	CLRF        main_j+0 
L__main180:
;BlackJack.mbas,394 :: 		for i = 0 TO NumberPlayers                  ' Deal to everyone including the dealer
	CLRF        main_i+0 
L__main184:
	MOVF        main_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__main188
;BlackJack.mbas,395 :: 		if not (Players[i].Outcome = OUT) then    ' Except people without money, of course
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       8
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main190
;BlackJack.mbas,396 :: 		Add_Card_To_Hand(@Players[i].Hand,Get_CardDeck_Card())  ' Add the card to the hand from the card deck
	CALL        _Get_CardDeck_Card+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Add_Card_To_Hand_Card+0 
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       FARG_Add_Card_To_Hand_PtrHand+0 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_Add_Card_To_Hand_PtrHand+1 
	CALL        _Add_Card_To_Hand+0, 0
L__main190:
;BlackJack.mbas,398 :: 		next i
	MOVF        main_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main188
	INCF        main_i+0, 1 
	GOTO        L__main184
L__main188:
;BlackJack.mbas,399 :: 		next j
	MOVF        main_j+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L__main183
	INCF        main_j+0, 1 
	GOTO        L__main180
L__main183:
;BlackJack.mbas,401 :: 		Update_Scores()                               ' Find the scores for everyone after the initial deal
	CALL        _update_scores+0, 0
;BlackJack.mbas,402 :: 		DISPLAY_TABLE(Players,NumberPlayers,1,HIDE_DEALER) ' Display the table for all to see
	MOVLW       _Players+0
	MOVWF       FARG_Display_Table_Players+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Display_Table_Players+1 
	MOVF        _NumberPlayers+0, 0 
	MOVWF       FARG_Display_Table_NumberPlayers+0 
	MOVLW       1
	MOVWF       FARG_Display_Table_Player_Turn+0 
	CLRF        FARG_Display_Table_Reveal_Dealer+0 
	CALL        _Display_Table+0, 0
;BlackJack.mbas,405 :: 		if (Retrieve_Card_Value(Players[DEALER].Hand.Cards[1]) = 1) then      ' The value of an Ace shows as 1, when we see a 1 we know it can be 1 or 11
	MOVF        _Players+1, 0 
	MOVWF       FARG_Retrieve_Card_Value_Card+0 
	CALL        _Retrieve_Card_Value+0, 0
	MOVF        R0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__main194
;BlackJack.mbas,406 :: 		Display_Dealer_Showing_Ace(@Players[DEALER].Hand)                   ' Tell players the dealer has an ace
	MOVLW       _Players+0
	MOVWF       FARG_Display_Dealer_Showing_Ace_PtrHand+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Display_Dealer_Showing_Ace_PtrHand+1 
	CALL        _Display_Dealer_Showing_Ace+0, 0
;BlackJack.mbas,407 :: 		DISPLAY_TABLE(Players,NumberPlayers,1,HIDE_DEALER) ' Display the table for all to see
	MOVLW       _Players+0
	MOVWF       FARG_Display_Table_Players+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Display_Table_Players+1 
	MOVF        _NumberPlayers+0, 0 
	MOVWF       FARG_Display_Table_NumberPlayers+0 
	MOVLW       1
	MOVWF       FARG_Display_Table_Player_Turn+0 
	CLRF        FARG_Display_Table_Reveal_Dealer+0 
	CALL        _Display_Table+0, 0
;BlackJack.mbas,408 :: 		VERY_LONG_DELAY                             ' Give players a chance to see their hand
	MOVLW       2
	MOVWF       R10, 0
	MOVLW       150
	MOVWF       R11, 0
	MOVLW       216
	MOVWF       R12, 0
	MOVLW       8
	MOVWF       R13, 0
L__main196:
	DECFSZ      R13, 1, 1
	BRA         L__main196
	DECFSZ      R12, 1, 1
	BRA         L__main196
	DECFSZ      R11, 1, 1
	BRA         L__main196
	DECFSZ      R10, 1, 1
	BRA         L__main196
	NOP
;BlackJack.mbas,409 :: 		for i = 1 to NumberPlayers                  ' Let's go through all our players
	MOVLW       1
	MOVWF       main_i+0 
L__main197:
	MOVF        main_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__main201
;BlackJack.mbas,410 :: 		PlayerAvailableBalance = Players[i].Bank - Players[i].Bet         ' How much money remains in player's bank after original bet
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       14
	ADDWF       R2, 0 
	MOVWF       R4 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       R5 
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       16
	ADDWF       R2, 0 
	MOVWF       FSR2L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR2L+1 
	MOVFF       R4, FSR0L+0
	MOVFF       R5, FSR0H+0
	MOVF        POSTINC2+0, 0 
	SUBWF       POSTINC0+0, 0 
	MOVWF       main_PlayerAvailableBalance+0 
	MOVF        POSTINC2+0, 0 
	SUBWFB      POSTINC0+0, 0 
	MOVWF       main_PlayerAvailableBalance+1 
;BlackJack.mbas,411 :: 		if Players[i].Bank = 0 then               ' If player has no money...
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       0
	XORWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main301
	MOVLW       0
	XORWF       R1, 0 
L__main301:
	BTFSS       STATUS+0, 2 
	GOTO        L__main203
;BlackJack.mbas,412 :: 		continue                                ' This player doesn't get a choice on insurance
	GOTO        L__main199
L__main203:
;BlackJack.mbas,414 :: 		if PlayerAvailableBalance > 0 then   ' Player cannot be All-In and get insurance
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       main_PlayerAvailableBalance+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main302
	MOVF        main_PlayerAvailableBalance+0, 0 
	SUBLW       0
L__main302:
	BTFSC       STATUS+0, 0 
	GOTO        L__main206
;BlackJack.mbas,415 :: 		Players[i].Insurance = INQUIRE_BET(PlayerAvailableBalance, i, true)   ' Inqurie if the player wants insurance
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       18
	ADDWF       R0, 0 
	MOVWF       FLOC__main+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FLOC__main+1 
	MOVF        main_PlayerAvailableBalance+0, 0 
	MOVWF       FARG_Inquire_Bet_Limit+0 
	MOVF        main_PlayerAvailableBalance+1, 0 
	MOVWF       FARG_Inquire_Bet_Limit+1 
	MOVF        main_i+0, 0 
	MOVWF       FARG_Inquire_Bet_PlayerNum+0 
	MOVLW       255
	MOVWF       FARG_Inquire_Bet_Insurance+0 
	CALL        _Inquire_Bet+0, 0
	MOVFF       FLOC__main+0, FSR1L+0
	MOVFF       FLOC__main+1, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
	GOTO        L__main207
;BlackJack.mbas,416 :: 		else
L__main206:
;BlackJack.mbas,417 :: 		continue                                ' A player without extra money to bet is skipped
	GOTO        L__main199
;BlackJack.mbas,418 :: 		end if
L__main207:
;BlackJack.mbas,419 :: 		next i
L__main199:
	MOVF        main_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main201
	INCF        main_i+0, 1 
	GOTO        L__main197
L__main201:
L__main194:
;BlackJack.mbas,424 :: 		if Players[DEALER].Outcome = BLACKJACK then   ' If after updating scores, the dealer has a blackjack
	MOVF        _Players+20, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__main210
;BlackJack.mbas,425 :: 		DISPLAY_DEALER_BLACKJACK(@Players[DEALER].Hand)    ' Let everyone know about the Dealer Blackjack
	MOVLW       _Players+0
	MOVWF       FARG_Display_Dealer_BlackJack_PtrHand+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Display_Dealer_BlackJack_PtrHand+1 
	CALL        _Display_Dealer_BlackJack+0, 0
;BlackJack.mbas,426 :: 		goto FINAL_RESULTS                          ' Skip playing the hands
	GOTO        L__main_final_results
L__main210:
;BlackJack.mbas,430 :: 		for i = 1 to NumberPlayers
	MOVLW       1
	MOVWF       main_i+0 
L__main214:
	MOVF        main_i+0, 0 
	SUBWF       _NumberPlayers+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__main218
;BlackJack.mbas,431 :: 		if Players[i].Bank = 0 then                 ' Player has no money...
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       0
	XORWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main303
	MOVLW       0
	XORWF       R1, 0 
L__main303:
	BTFSS       STATUS+0, 2 
	GOTO        L__main220
;BlackJack.mbas,432 :: 		continue                                  ' This player doesn't play
	GOTO        L__main216
L__main220:
;BlackJack.mbas,434 :: 		while Players[i].Outcome = TBD              ' Only players that are not pre-determined get to play
L__main223:
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main224
;BlackJack.mbas,435 :: 		Splt = false                              ' TODO - NOT YET IMPLEMENTED
	CLRF        main_Splt+0 
;BlackJack.mbas,436 :: 		ByeBye = false                            ' initialize ByeBye
	CLRF        main_ByeBye+0 
;BlackJack.mbas,437 :: 		DD = false                                ' Initialize DD
	CLRF        main_DD+0 
;BlackJack.mbas,438 :: 		if Players[i].Move = 0 then               ' On first move, offer Surrender as well as hit or stay
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       21
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main228
;BlackJack.mbas,439 :: 		ByeBye = true                           ' Player can surrender on first move
	MOVLW       255
	MOVWF       main_ByeBye+0 
;BlackJack.mbas,440 :: 		if ((Players[i].Bet * 2) <= Players[i].Bank) then  ' If player has enough to double down on first move
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       16
	ADDWF       R2, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R5 
	MOVF        POSTINC0+0, 0 
	MOVWF       R6 
	MOVF        R5, 0 
	MOVWF       R3 
	MOVF        R6, 0 
	MOVWF       R4 
	RLCF        R3, 1 
	BCF         R3, 0 
	RLCF        R4, 1 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       14
	ADDWF       R0, 0 
	MOVWF       FSR2L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR2L+1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
	MOVLW       128
	XORWF       R2, 0 
	MOVWF       R0 
	MOVLW       128
	XORWF       R4, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main304
	MOVF        R3, 0 
	SUBWF       R1, 0 
L__main304:
	BTFSS       STATUS+0, 0 
	GOTO        L__main231
;BlackJack.mbas,441 :: 		DD = true                             ' Allow a double down
	MOVLW       255
	MOVWF       main_DD+0 
L__main231:
;BlackJack.mbas,442 :: 		end if
L__main228:
;BlackJack.mbas,445 :: 		DISPLAY_PLAYER_MOVE_OPTIONS(i, ByeBye, DD, Splt)    ' Display the options for the users
	MOVF        main_i+0, 0 
	MOVWF       FARG_Display_Player_Move_Options_playernumber+0 
	MOVF        main_ByeBye+0, 0 
	MOVWF       FARG_Display_Player_Move_Options_byebye+0 
	MOVF        main_DD+0, 0 
	MOVWF       FARG_Display_Player_Move_Options_dd+0 
	MOVF        main_Splt+0, 0 
	MOVWF       FARG_Display_Player_Move_Options_split+0 
	CALL        _Display_Player_Move_Options+0, 0
;BlackJack.mbas,446 :: 		Update_Scores()                           ' Always update scores before displaying the table
	CALL        _update_scores+0, 0
;BlackJack.mbas,447 :: 		DISPLAY_TABLE(Players,NumberPlayers,i,HIDE_DEALER)  ' Display the table
	MOVLW       _Players+0
	MOVWF       FARG_Display_Table_Players+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Display_Table_Players+1 
	MOVF        _NumberPlayers+0, 0 
	MOVWF       FARG_Display_Table_NumberPlayers+0 
	MOVF        main_i+0, 0 
	MOVWF       FARG_Display_Table_Player_Turn+0 
	CLRF        FARG_Display_Table_Reveal_Dealer+0 
	CALL        _Display_Table+0, 0
;BlackJack.mbas,449 :: 		PlayerAction = INQUIRE_PLAYER_MOVE(ByeBye, DD, Splt)' Get the players next move
	MOVF        main_ByeBye+0, 0 
	MOVWF       FARG_Inquire_Player_Move_byebye+0 
	MOVF        main_DD+0, 0 
	MOVWF       FARG_Inquire_Player_Move_dd+0 
	MOVF        main_Splt+0, 0 
	MOVWF       FARG_Inquire_Player_Move_splt+0 
	CALL        _Inquire_Player_Move+0, 0
	MOVF        R0, 0 
	MOVWF       main_PlayerAction+0 
;BlackJack.mbas,450 :: 		Players[i].Move = Players[i].Move + 1     ' Player made a move
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       21
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       21
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	ADDLW       1
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,451 :: 		if PlayerAction = STAY then               ' Go on to next player and leave TBD
	MOVF        main_PlayerAction+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main234
;BlackJack.mbas,452 :: 		Break
	GOTO        L__main224
L__main234:
;BlackJack.mbas,454 :: 		if PlayerAction = SURRENDER then          ' If player decided to surrender
	MOVF        main_PlayerAction+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__main237
;BlackJack.mbas,455 :: 		Players[i].Bet = Players[i].Bet div 2   ' Cut the bet in half, this will be a loss
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       16
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       16
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	BTFSC       R1, 6 
	BSF         R1, 7 
	BTFSS       R1, 7 
	GOTO        L__main305
	BTFSS       STATUS+0, 0 
	GOTO        L__main305
	INFSNZ      R0, 1 
	INCF        R1, 1 
L__main305:
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,456 :: 		Players[i].Outcome = SURRENDER          ' Set player's outcome to surrender
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVLW       2
	MOVWF       POSTINC1+0 
L__main237:
;BlackJack.mbas,458 :: 		if PlayerAction = DOUBLE_DOWN then        ' Living dangerously, ok, double the bet
	MOVF        main_PlayerAction+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__main240
;BlackJack.mbas,459 :: 		Players[i].Bet = Players[i].Bet * 2     ' Double the player's bet
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       16
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       16
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;BlackJack.mbas,460 :: 		Display_LCD_Drawing_One_Card_Msg()      ' Display the player is getting one more card
	CALL        _Display_LCD_Drawing_One_Card_Msg+0, 0
;BlackJack.mbas,461 :: 		Add_Card_To_Hand(@Players[i].Hand,Get_CardDeck_Card()) ' Add a card to player's hand
	CALL        _Get_CardDeck_Card+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Add_Card_To_Hand_Card+0 
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       FARG_Add_Card_To_Hand_PtrHand+0 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_Add_Card_To_Hand_PtrHand+1 
	CALL        _Add_Card_To_Hand+0, 0
;BlackJack.mbas,462 :: 		Evaluate_Hand(i)                        ' Evaluate the hand which will set a new outcome
	MOVF        main_i+0, 0 
	MOVWF       FARG_Evaluate_Hand_PlayerNumber+0 
	CALL        _Evaluate_Hand+0, 0
;BlackJack.mbas,463 :: 		if Players[i].Outcome = TWENTYONE then  ' If the player got 21, congratulate him
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L__main243
;BlackJack.mbas,464 :: 		DISPLAY_LCD_TWENTY_ONE_MSG()          ' Play the 21 message
	CALL        _Display_LCD_Twenty_One_Msg+0, 0
L__main243:
;BlackJack.mbas,466 :: 		if Players[i].Outcome = BUST then       ' If the player busted, then tell him
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L__main246
;BlackJack.mbas,467 :: 		DISPLAY_LCD_BUSTED_MSG                ' Display busted message
	CALL        _Display_LCD_Busted_Msg+0, 0
L__main246:
;BlackJack.mbas,469 :: 		Update_Scores()                         ' Always update scores before displaying the table
	CALL        _update_scores+0, 0
;BlackJack.mbas,470 :: 		DISPLAY_TABLE(Players,NumberPlayers,i,HIDE_DEALER) ' Display the table
	MOVLW       _Players+0
	MOVWF       FARG_Display_Table_Players+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Display_Table_Players+1 
	MOVF        _NumberPlayers+0, 0 
	MOVWF       FARG_Display_Table_NumberPlayers+0 
	MOVF        main_i+0, 0 
	MOVWF       FARG_Display_Table_Player_Turn+0 
	CLRF        FARG_Display_Table_Reveal_Dealer+0 
	CALL        _Display_Table+0, 0
;BlackJack.mbas,471 :: 		Break                                   ' Go to the next player, this player is finished
	GOTO        L__main224
L__main240:
;BlackJack.mbas,473 :: 		if PlayerAction = HIT then                ' Player takes a card
	MOVF        main_PlayerAction+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__main249
;BlackJack.mbas,474 :: 		Add_Card_To_Hand(@Players[i].Hand,Get_CardDeck_Card()) ' Add a card to player's hand
	CALL        _Get_CardDeck_Card+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Add_Card_To_Hand_Card+0 
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 0 
	MOVWF       FARG_Add_Card_To_Hand_PtrHand+0 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_Add_Card_To_Hand_PtrHand+1 
	CALL        _Add_Card_To_Hand+0, 0
;BlackJack.mbas,475 :: 		Evaluate_Hand(i)                        ' Evaluate the hand which will set a new outcome
	MOVF        main_i+0, 0 
	MOVWF       FARG_Evaluate_Hand_PlayerNumber+0 
	CALL        _Evaluate_Hand+0, 0
;BlackJack.mbas,476 :: 		if Players[i].Outcome = TWENTYONE then  ' If the player got 21, congratulate him
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L__main252
;BlackJack.mbas,477 :: 		DISPLAY_LCD_TWENTY_ONE_MSG()          ' Play the 21 message
	CALL        _Display_LCD_Twenty_One_Msg+0, 0
L__main252:
;BlackJack.mbas,479 :: 		if Players[i].Outcome = BUST then       ' If the player busted, then tell him
	MOVLW       22
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        main_i+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Players+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_Players+0)
	ADDWFC      R1, 1 
	MOVLW       20
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L__main255
;BlackJack.mbas,480 :: 		DISPLAY_LCD_BUSTED_MSG                ' Display busted message
	CALL        _Display_LCD_Busted_Msg+0, 0
L__main255:
;BlackJack.mbas,482 :: 		Update_Scores()                         ' Always update scores before displaying the table
	CALL        _update_scores+0, 0
;BlackJack.mbas,483 :: 		DISPLAY_TABLE(Players,NumberPlayers,i,HIDE_DEALER) ' Display the table
	MOVLW       _Players+0
	MOVWF       FARG_Display_Table_Players+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Display_Table_Players+1 
	MOVF        _NumberPlayers+0, 0 
	MOVWF       FARG_Display_Table_NumberPlayers+0 
	MOVF        main_i+0, 0 
	MOVWF       FARG_Display_Table_Player_Turn+0 
	CLRF        FARG_Display_Table_Reveal_Dealer+0 
	CALL        _Display_Table+0, 0
L__main249:
;BlackJack.mbas,485 :: 		wend                                        ' Next move
	GOTO        L__main223
L__main224:
;BlackJack.mbas,486 :: 		next i                                        ' Next player
L__main216:
	MOVF        main_i+0, 0 
	XORWF       _NumberPlayers+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main218
	INCF        main_i+0, 1 
	GOTO        L__main214
L__main218:
;BlackJack.mbas,490 :: 		while (Players[DEALER].SumHand < 17)                     ' While player hand less than 17
L__main259:
	MOVLW       17
	SUBWF       _Players+13, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__main260
;BlackJack.mbas,491 :: 		Players[DEALER].Move = Players[DEALER].Move + 1        ' Dealer made a move, only needed in case of 21, so it is not blackjack
	INCF        _Players+21, 1 
;BlackJack.mbas,492 :: 		DealerDraw = Get_CardDeck_Card()                       ' Draw a new card
	CALL        _Get_CardDeck_Card+0, 0
	MOVF        R0, 0 
	MOVWF       main_DealerDraw+0 
;BlackJack.mbas,493 :: 		Add_Card_To_Hand(@Players[DEALER].Hand,DealerDraw)     ' Add the card to the dealer's hand
	MOVLW       _Players+0
	MOVWF       FARG_Add_Card_To_Hand_PtrHand+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Add_Card_To_Hand_PtrHand+1 
	MOVF        R0, 0 
	MOVWF       FARG_Add_Card_To_Hand_Card+0 
	CALL        _Add_Card_To_Hand+0, 0
;BlackJack.mbas,494 :: 		Evaluate_Hand(DEALER)                                  ' Evaluate the dealer's hand
	CLRF        FARG_Evaluate_Hand_PlayerNumber+0 
	CALL        _Evaluate_Hand+0, 0
;BlackJack.mbas,495 :: 		DISPLAY_LCD_DEALER_DRAW_MSG(DealerDraw,Players[DEALER].SumHand) ' Display dealer draw and new dealer total
	MOVF        main_DealerDraw+0, 0 
	MOVWF       FARG_Display_LCD_Dealer_Draw_Msg_DealerDraw+0 
	MOVF        _Players+13, 0 
	MOVWF       FARG_Display_LCD_Dealer_Draw_Msg_dealertotal+0 
	CALL        _Display_LCD_Dealer_Draw_Msg+0, 0
;BlackJack.mbas,496 :: 		if Players[DEALER].Outcome = TWENTYONE then            ' Dealer draws to 21
	MOVF        _Players+20, 0 
	XORLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L__main264
;BlackJack.mbas,497 :: 		DISPLAY_LCD_DEALER_TWENTY_ONE_MSG()                  ' Play the 21 message
	CALL        _Display_LCD_Dealer_Twenty_One_Msg+0, 0
;BlackJack.mbas,498 :: 		break
	GOTO        L__main260
L__main264:
;BlackJack.mbas,500 :: 		if Players[DEALER].Outcome = BUST then                 ' Dealer went bust
	MOVF        _Players+20, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L__main267
;BlackJack.mbas,501 :: 		DISPLAY_LCD_DEALER_BUSTED_MSG                        ' Display busted message
	CALL        _Display_LCD_Dealer_Busted_Msg+0, 0
;BlackJack.mbas,502 :: 		break
	GOTO        L__main260
L__main267:
;BlackJack.mbas,504 :: 		Update_Scores()                                        ' Always update scores before displaying the table
	CALL        _update_scores+0, 0
;BlackJack.mbas,505 :: 		DISPLAY_TABLE(Players,NumberPlayers,0, REVEAL_DEALER)  ' Display the table after each dealer move
	MOVLW       _Players+0
	MOVWF       FARG_Display_Table_Players+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Display_Table_Players+1 
	MOVF        _NumberPlayers+0, 0 
	MOVWF       FARG_Display_Table_NumberPlayers+0 
	CLRF        FARG_Display_Table_Player_Turn+0 
	MOVLW       255
	MOVWF       FARG_Display_Table_Reveal_Dealer+0 
	CALL        _Display_Table+0, 0
;BlackJack.mbas,506 :: 		VERY_LONG_DELAY
	MOVLW       2
	MOVWF       R10, 0
	MOVLW       150
	MOVWF       R11, 0
	MOVLW       216
	MOVWF       R12, 0
	MOVLW       8
	MOVWF       R13, 0
L__main269:
	DECFSZ      R13, 1, 1
	BRA         L__main269
	DECFSZ      R12, 1, 1
	BRA         L__main269
	DECFSZ      R11, 1, 1
	BRA         L__main269
	DECFSZ      R10, 1, 1
	BRA         L__main269
	NOP
;BlackJack.mbas,507 :: 		wend
	GOTO        L__main259
L__main260:
;BlackJack.mbas,510 :: 		FINAL_RESULTS:
L__main_final_results:
;BlackJack.mbas,511 :: 		Update_Scores                                            ' Update scores before final outcome
	CALL        _update_scores+0, 0
;BlackJack.mbas,512 :: 		Final_Outcomes()                                         ' Set Win, Loss, or Draw
	CALL        _Final_Outcomes+0, 0
;BlackJack.mbas,513 :: 		DISPLAY_LCD_ADJUSTING_MONEY_MSG()                        ' Display that we are adjusting Money
	CALL        _Display_LCD_Adjusting_Money_Msg+0, 0
;BlackJack.mbas,514 :: 		Update_Scores()                                          ' Always update scores before displaying the table
	CALL        _update_scores+0, 0
;BlackJack.mbas,515 :: 		DISPLAY_TABLE(Players,NumberPlayers,0, REVEAL_DEALER)    ' Display the table
	MOVLW       _Players+0
	MOVWF       FARG_Display_Table_Players+0 
	MOVLW       hi_addr(_Players+0)
	MOVWF       FARG_Display_Table_Players+1 
	MOVF        _NumberPlayers+0, 0 
	MOVWF       FARG_Display_Table_NumberPlayers+0 
	CLRF        FARG_Display_Table_Player_Turn+0 
	MOVLW       255
	MOVWF       FARG_Display_Table_Reveal_Dealer+0 
	CALL        _Display_Table+0, 0
;BlackJack.mbas,516 :: 		VERY_LONG_DELAY
	MOVLW       2
	MOVWF       R10, 0
	MOVLW       150
	MOVWF       R11, 0
	MOVLW       216
	MOVWF       R12, 0
	MOVLW       8
	MOVWF       R13, 0
L__main270:
	DECFSZ      R13, 1, 1
	BRA         L__main270
	DECFSZ      R12, 1, 1
	BRA         L__main270
	DECFSZ      R11, 1, 1
	BRA         L__main270
	DECFSZ      R10, 1, 1
	BRA         L__main270
	NOP
;BlackJack.mbas,519 :: 		Print_And_Adjust_Totals()                                ' Go to a routing that will finalize hand
	CALL        _Print_And_Adjust_Totals+0, 0
;BlackJack.mbas,520 :: 		VERY_LONG_DELAY
	MOVLW       2
	MOVWF       R10, 0
	MOVLW       150
	MOVWF       R11, 0
	MOVLW       216
	MOVWF       R12, 0
	MOVLW       8
	MOVWF       R13, 0
L__main272:
	DECFSZ      R13, 1, 1
	BRA         L__main272
	DECFSZ      R12, 1, 1
	BRA         L__main272
	DECFSZ      R11, 1, 1
	BRA         L__main272
	DECFSZ      R10, 1, 1
	BRA         L__main272
	NOP
;BlackJack.mbas,523 :: 		if (Players[DEALER].Bank = (DealerStartingBalance + (PlayerStartingBalance * NumberPlayers))) then  'We know dealer won if all the money is in the dealer's bank
	MOVF        main_PlayerStartingBalance+0, 0 
	MOVWF       R0 
	MOVF        main_PlayerStartingBalance+1, 0 
	MOVWF       R1 
	MOVF        _NumberPlayers+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        R0, 0 
	ADDWF       main_DealerStartingBalance+0, 0 
	MOVWF       R2 
	MOVF        R1, 0 
	ADDWFC      main_DealerStartingBalance+1, 0 
	MOVWF       R3 
	MOVF        _Players+15, 0 
	XORWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main306
	MOVF        R2, 0 
	XORWF       _Players+14, 0 
L__main306:
	BTFSS       STATUS+0, 2 
	GOTO        L__main275
;BlackJack.mbas,524 :: 		DISPLAY_LOSER()                                        ' Tell player they lost
	CALL        _Display_Loser+0, 0
;BlackJack.mbas,525 :: 		goto END_GAME                                          ' We don't ask to play again, they can simply hit reset
	GOTO        L__main_end_game
L__main275:
;BlackJack.mbas,527 :: 		if (Players[DEALER].Bank <= 0) then                      ' We know dealer lost if their bank is out of money
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       _Players+15, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main307
	MOVF        _Players+14, 0 
	SUBLW       0
L__main307:
	BTFSS       STATUS+0, 0 
	GOTO        L__main279
;BlackJack.mbas,528 :: 		EEPROM_WRITE(0x01, NumberWins + 1 )                   ' Save to EEPROM a win!  Yay, it will show up after next reset.
	MOVLW       1
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        main_NumberWins+0, 0 
	ADDLW       1
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;BlackJack.mbas,529 :: 		DISPLAY_WINNER()                                       ' Tell player then won
	CALL        _Display_Winner+0, 0
;BlackJack.mbas,530 :: 		goto END_GAME                                          ' We don't actually get here, because the win message loops...
	GOTO        L__main_end_game
L__main279:
;BlackJack.mbas,533 :: 		Discard_Players_Cards()                                  ' If the dealer has not won or lost, then move player hands to discard pile
	CALL        _Discard_Players_Cards+0, 0
;BlackJack.mbas,534 :: 		goto SHUFFLE                                             ' Return to the point where we shuffle the cards
	GOTO        L__main_shuffle
;BlackJack.mbas,536 :: 		END_GAME:
L__main_end_game:
L_end_main:
	GOTO        $+0
; end of _main
