
_Init_Inputs:

;InPutFromPortCButtons.mbas,24 :: 		sub procedure Init_Inputs()
;InPutFromPortCButtons.mbas,28 :: 		ANSELC = 0            ' This would be input
	CLRF        ANSELC+0 
;InPutFromPortCButtons.mbas,30 :: 		end sub
L_end_Init_Inputs:
	RETURN      0
; end of _Init_Inputs

_Input_T_Or_F:

;InPutFromPortCButtons.mbas,32 :: 		sub function Input_T_Or_F(dim byref Prompt as string[16]) as boolean
;InPutFromPortCButtons.mbas,39 :: 		PrintLCD(Prompt)                                      ' Display the prompt
	MOVF        FARG_Input_T_Or_F_Prompt+0, 0 
	MOVWF       FARG_PrintLCD_Text+0 
	MOVF        FARG_Input_T_Or_F_Prompt+1, 0 
	MOVWF       FARG_PrintLCD_Text+1 
	CALL        _PrintLCD+0, 0
;InPutFromPortCButtons.mbas,40 :: 		PrintLCD("C0 = N, C1 = Y")                            ' Display the options, which will push prompt to first row
	MOVLW       67
	MOVWF       ?LocalText_Input_T_Or_F+0 
	MOVLW       48
	MOVWF       ?LocalText_Input_T_Or_F+1 
	MOVLW       32
	MOVWF       ?LocalText_Input_T_Or_F+2 
	MOVLW       61
	MOVWF       ?LocalText_Input_T_Or_F+3 
	MOVLW       32
	MOVWF       ?LocalText_Input_T_Or_F+4 
	MOVLW       78
	MOVWF       ?LocalText_Input_T_Or_F+5 
	MOVLW       44
	MOVWF       ?LocalText_Input_T_Or_F+6 
	MOVLW       32
	MOVWF       ?LocalText_Input_T_Or_F+7 
	MOVLW       67
	MOVWF       ?LocalText_Input_T_Or_F+8 
	MOVLW       49
	MOVWF       ?LocalText_Input_T_Or_F+9 
	MOVLW       32
	MOVWF       ?LocalText_Input_T_Or_F+10 
	MOVLW       61
	MOVWF       ?LocalText_Input_T_Or_F+11 
	MOVLW       32
	MOVWF       ?LocalText_Input_T_Or_F+12 
	MOVLW       89
	MOVWF       ?LocalText_Input_T_Or_F+13 
	CLRF        ?LocalText_Input_T_Or_F+14 
	MOVLW       ?LocalText_Input_T_Or_F+0
	MOVWF       FARG_PrintLCD_Text+0 
	MOVLW       hi_addr(?LocalText_Input_T_Or_F+0)
	MOVWF       FARG_PrintLCD_Text+1 
	CALL        _PrintLCD+0, 0
;InPutFromPortCButtons.mbas,41 :: 		while true                                            ' Wait for C0 or C1 to be pressed
L__Input_T_Or_F3:
;InPutFromPortCButtons.mbas,42 :: 		if Button(PORTC, 0, 100, 1) then                    ' If C0 is pressed
	MOVLW       PORTC+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTC+0)
	MOVWF       FARG_Button_port+1 
	CLRF        FARG_Button_pin+0 
	MOVLW       100
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Input_T_Or_F8
;InPutFromPortCButtons.mbas,43 :: 		PrintLCD("SELECTED NO")                           ' Display that No was selected
	MOVLW       83
	MOVWF       ?LocalText_Input_T_Or_F+0 
	MOVLW       69
	MOVWF       ?LocalText_Input_T_Or_F+1 
	MOVLW       76
	MOVWF       ?LocalText_Input_T_Or_F+2 
	MOVLW       69
	MOVWF       ?LocalText_Input_T_Or_F+3 
	MOVLW       67
	MOVWF       ?LocalText_Input_T_Or_F+4 
	MOVLW       84
	MOVWF       ?LocalText_Input_T_Or_F+5 
	MOVLW       69
	MOVWF       ?LocalText_Input_T_Or_F+6 
	MOVLW       68
	MOVWF       ?LocalText_Input_T_Or_F+7 
	MOVLW       32
	MOVWF       ?LocalText_Input_T_Or_F+8 
	MOVLW       78
	MOVWF       ?LocalText_Input_T_Or_F+9 
	MOVLW       79
	MOVWF       ?LocalText_Input_T_Or_F+10 
	CLRF        ?LocalText_Input_T_Or_F+11 
	MOVLW       ?LocalText_Input_T_Or_F+0
	MOVWF       FARG_PrintLCD_Text+0 
	MOVLW       hi_addr(?LocalText_Input_T_Or_F+0)
	MOVWF       FARG_PrintLCD_Text+1 
	CALL        _PrintLCD+0, 0
;InPutFromPortCButtons.mbas,44 :: 		PrintLCD("")                                      ' Move "SELECTED NO" to the first line
	CLRF        ?LocalText_Input_T_Or_F+0 
	MOVLW       ?LocalText_Input_T_Or_F+0
	MOVWF       FARG_PrintLCD_Text+0 
	MOVLW       hi_addr(?LocalText_Input_T_Or_F+0)
	MOVWF       FARG_PrintLCD_Text+1 
	CALL        _PrintLCD+0, 0
;InPutFromPortCButtons.mbas,45 :: 		RESULT = FALSE                                    ' Set result to FALSE
	CLRF        Input_T_Or_F_local_result+0 
;InPutFromPortCButtons.mbas,46 :: 		break                                             ' Break out of loop to return to caller
	GOTO        L__Input_T_Or_F4
L__Input_T_Or_F8:
;InPutFromPortCButtons.mbas,48 :: 		if Button(PORTC, 1, 100, 1) then                    ' If C1 is pressed
	MOVLW       PORTC+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTC+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       1
	MOVWF       FARG_Button_pin+0 
	MOVLW       100
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Input_T_Or_F11
;InPutFromPortCButtons.mbas,49 :: 		PrintLCD("SELECTED YES")                          ' Display that Yes was selected
	MOVLW       83
	MOVWF       ?LocalText_Input_T_Or_F+0 
	MOVLW       69
	MOVWF       ?LocalText_Input_T_Or_F+1 
	MOVLW       76
	MOVWF       ?LocalText_Input_T_Or_F+2 
	MOVLW       69
	MOVWF       ?LocalText_Input_T_Or_F+3 
	MOVLW       67
	MOVWF       ?LocalText_Input_T_Or_F+4 
	MOVLW       84
	MOVWF       ?LocalText_Input_T_Or_F+5 
	MOVLW       69
	MOVWF       ?LocalText_Input_T_Or_F+6 
	MOVLW       68
	MOVWF       ?LocalText_Input_T_Or_F+7 
	MOVLW       32
	MOVWF       ?LocalText_Input_T_Or_F+8 
	MOVLW       89
	MOVWF       ?LocalText_Input_T_Or_F+9 
	MOVLW       69
	MOVWF       ?LocalText_Input_T_Or_F+10 
	MOVLW       83
	MOVWF       ?LocalText_Input_T_Or_F+11 
	CLRF        ?LocalText_Input_T_Or_F+12 
	MOVLW       ?LocalText_Input_T_Or_F+0
	MOVWF       FARG_PrintLCD_Text+0 
	MOVLW       hi_addr(?LocalText_Input_T_Or_F+0)
	MOVWF       FARG_PrintLCD_Text+1 
	CALL        _PrintLCD+0, 0
;InPutFromPortCButtons.mbas,50 :: 		PrintLCD("")                                      ' Move "SELECTED YES" to the first line
	CLRF        ?LocalText_Input_T_Or_F+0 
	MOVLW       ?LocalText_Input_T_Or_F+0
	MOVWF       FARG_PrintLCD_Text+0 
	MOVLW       hi_addr(?LocalText_Input_T_Or_F+0)
	MOVWF       FARG_PrintLCD_Text+1 
	CALL        _PrintLCD+0, 0
;InPutFromPortCButtons.mbas,51 :: 		RESULT = TRUE                                     ' Set result to TRUE
	MOVLW       255
	MOVWF       Input_T_Or_F_local_result+0 
;InPutFromPortCButtons.mbas,52 :: 		break                                             ' Break out of loop to return to caller
	GOTO        L__Input_T_Or_F4
L__Input_T_Or_F11:
;InPutFromPortCButtons.mbas,54 :: 		wend
	GOTO        L__Input_T_Or_F3
L__Input_T_Or_F4:
;InPutFromPortCButtons.mbas,55 :: 		end sub
	MOVF        Input_T_Or_F_local_result+0, 0 
	MOVWF       R0 
L_end_Input_T_Or_F:
	RETURN      0
; end of _Input_T_Or_F

_Input_Buttons:

;InPutFromPortCButtons.mbas,64 :: 		dim i as byte                         ' Our loop variabler
;InPutFromPortCButtons.mbas,65 :: 		i = 0                                 ' Initialize to 0 for while loop
	CLRF        Input_Buttons_i+0 
;InPutFromPortCButtons.mbas,66 :: 		while true                            ' Continue until valid button press
L__Input_Buttons15:
;InPutFromPortCButtons.mbas,67 :: 		if Button(PORTC, i, 100, 1) then    ' Check to see if the button is pressed
	MOVLW       PORTC+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTC+0)
	MOVWF       FARG_Button_port+1 
	MOVF        Input_Buttons_i+0, 0 
	MOVWF       FARG_Button_pin+0 
	MOVLW       100
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Input_Buttons20
;InPutFromPortCButtons.mbas,68 :: 		RESULT = i                        ' When there is a press, set the RESULT
	MOVF        Input_Buttons_i+0, 0 
	MOVWF       Input_Buttons_local_result+0 
;InPutFromPortCButtons.mbas,69 :: 		break                             ' Break to return to caller
	GOTO        L__Input_Buttons16
L__Input_Buttons20:
;InPutFromPortCButtons.mbas,71 :: 		i = (i + 1) mod (limit + 1)         ' Otherwise add 1, using MOD to go back to 0 when incrementing at limit
	MOVF        Input_Buttons_i+0, 0 
	ADDLW       1
	MOVWF       R0 
	MOVF        FARG_Input_Buttons_limit+0, 0 
	ADDLW       1
	MOVWF       R4 
	CALL        _Div_8x8_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       Input_Buttons_i+0 
;InPutFromPortCButtons.mbas,72 :: 		wend
	GOTO        L__Input_Buttons15
L__Input_Buttons16:
;InPutFromPortCButtons.mbas,73 :: 		end sub
	MOVF        Input_Buttons_local_result+0, 0 
	MOVWF       R0 
L_end_Input_Buttons:
	RETURN      0
; end of _Input_Buttons
